//////////////////////////////////////////////////////////////////
// Function file for Armed Assault
// Created by: (AEF)Wolffy.au [2CAV]
// Created: 20090619
// Modified: 20100325
// Contact: http://creobellum.org
// Purpose: Setup mission modules and dynamic objects
///////////////////////////////////////////////////////////////////
NumWrecks = 150;

cutText ["Now joining a creoBellum.org mission...\n\nMission concept and design by Wolffy.au", "BLACK FADED", 1]; 	// This next line can be commented out or removed if it interferes with intro movies  
1 cutRsc ["CBTitle", "PLAIN", 1];
2 cutRsc ["CBFlag","PLAIN", 1];

if (isServer) then {
	if(isNil "mission_init") then {
		mission_init = false;
		publicVariable "mission_init";
	};

	if(isNil "tasksPublicVariable") then {
		tasksPublicVariable = [false, false, false, false, false];
		PublicVariable "tasksPublicVariable";
		call {[] execVM "crb_scripts\JIPBriefing.sqf"};
	};
} else {
	waitUntil{!isNil "mission_init"};
	waitUntil{!isNil "tasksPublicVariable"};	
};

// ====================================================================================
// F2 - Mission Conditions Selector
// Credits: Please see the F2 online manual (http://www.ferstaberinde.com/f2/en/)

player globalChat "Initialising weather and time";
0 = [] execVM "f\common\f_setMissionConditions.sqf";

player globalChat "Setup Wrecks";
if (isServer) then {
	[] spawn {
		_wrecks = [
			"BMP2Wreck",
			"BRDMWreck",
			"HMMWVWreck",
			"LADAWreck",
			"Mi8Wreck",
			"SKODAWreck",
			"T72Wreck",
			"T72WreckTurret",
			"UAZWreck",
			"UH1Wreck",
			"datsun01Wreck",
			"datsun02Wreck",
			"hiluxWreck",
			"UralWreck"
		];
		_sizeAO = markerSize "AO";
		for "_i" from 1 to NumWrecks do {
			_vehclass = _wrecks select floor(random count _wrecks);
			_size = if ((_sizeAO select 0) > (_sizeAO select 1)) then {(_sizeAO select 0) * 0.8;} else {(_sizeAO select 1) * 0.8;};
			_veh = createVehicle [_vehclass, markerPos "AO", [], _size, "NONE"];
			_veh setDir random 360;
			_veh setVectorUp [0,0,1];
		};
	};
};
if(isNil "END_MISSION") then {
	END_MISSION = false;
	PublicVariable "END_MISSION";
};
	
player globalChat "Initialising BIS Functions";
waituntil {!isnil "bis_fnc_init"};

player globalChat "Initialising ACE";
waitUntil{!isNil "ace_main"};

player globalChat "Perform processInitCommands";
processInitCommands;

player globalChat "Server viewdist and terrain";
setViewDistance 2000;
setTerrainGrid 50;

defValueParam1 = 99;
defValueParam2 = 1;

player globalChat "Initialising CEP AI Unit Caching";
call{[2000] execVM "coop_essential\cep_init.sqf";};

if (!isDedicated) then {
	player globalChat "Executing JIP";
	call{[] execVM "crB_scripts\JIP.sqf";};
};

player globalChat "Kitting Playable AI";
if(isServer) then {
	{
		call{[_x] execVM "crB_scripts\PlayerInit.sqf";};
	} forEach (playableUnits + switchableUnits);
};

player globalChat "Setup hide corpses";
call{[50, 45] execVM "crB_scripts\crB_HideCorpses.sqf";};

player globalChat "Perform finishMissionInit";
finishMissionInit;

if (isServer) then {
	mission_init = true;
	publicVariable "mission_init";
} else {
	waitUntil{mission_init};
};
player globalChat "Mission Initialisation Complete";

sleep 5;

hint "Change your View Distance Settings and Team Status options on the flagpole.";