//////////////////////////////////////////////////////////////////
// Function file for Armed Assault
// Created by: (AEF)Wolffy.au [2CAV]
// Created: 20090619
// Version: 20090620 - Initial release
// Contact: http://creobellum.org
// Purpose: Control briefing and tasks incl JIP
///////////////////////////////////////////////////////////////////
STR_OBJ1 = "Clear Lina";
STR_OBJ2 = "Clear Cainna Wind";
STR_OBJ3 = "Clear Fishala";
STR_OBJ4 = "Clear Camara";
STR_OBJ5 = "Clear Ramon's Plantation";

taskSetup = {		
	// Creating notes
	if(isNil "tskCredits") then {
		player createDiaryRecord ["Diary",["Credits", "Mission concept and design by Wolffy.au<br/>Thanks to:<br/>    The ever willing mission testers from cB &amp; AEF<br/>    Random Group Spawn code by Odin<br/>    Team Status Dialog by Dr Eyeball<br/>    CEP AI Unit Caching by Myke<br/>    Weapons on Respawn/Splash Screen/ACE Weapons Box by Xeno<br/>    Improved AI Driving by Sakura Chan<br/>    Improved taskDefend and taskPatrol by Binesi<br/>    On-the-fly GFX Changer by Deadfast<br/>    Missions Conditions Selector - F2 MP Framework<br/>    Simple Vehicle Respawn Script by Tophe of stgta Ops<br/><br/>Visit us a http://creoBellum.org"]];
		player createDiaryRecord ["Diary",["Current Intel", "Molatian Rebel forces have recently increased their presence on Isla Vixena. There have been civilian reports that rebels are often intimidating locals in any of the 5 major towns. Rebel forces are armed with light arms.<br/><br/>A small USMC task force has been deployed to patrol the island and maintain control of the region. Ammunition can be found in the vehicle cargo. Patrol each town to identify and clear rebel presence."]];
		tskCredits = true;
	};

	// Creating tasks
	if(isNil "tskObj5") then {
		tskObj5 = player createSimpleTask [STR_OBJ5];
		tskObj5 setSimpleTaskDescription ["Clear <marker name='OBJ5'>enemy stronghold</marker> of enemy hostiles", STR_OBJ5, STR_OBJ5];
		tskObj5 setSimpleTaskDestination (getMarkerPos "OBJ5");
	};
	if(isNil "tskObj4") then {
		tskObj4 = player createSimpleTask [STR_OBJ4];
		tskObj4 setSimpleTaskDescription ["Patrol and clear <marker name='OBJ4'>Camara</marker> of enemy hostiles", STR_OBJ4, STR_OBJ4];
		tskObj4 setSimpleTaskDestination (getMarkerPos "OBJ4");
	};
	if(isNil "tskObj3") then {
		tskObj3 = player createSimpleTask [STR_OBJ3];
		tskObj3 setSimpleTaskDescription ["Patrol and clear <marker name='OBJ3'>Fishala</marker> of enemy hostiles", STR_OBJ3, STR_OBJ3];
		tskObj3 setSimpleTaskDestination (getMarkerPos "OBJ3");
	};
	if(isNil "tskObj2") then {
		tskObj2 = player createSimpleTask [STR_OBJ2];
		tskObj2 setSimpleTaskDescription ["Patrol and clear <marker name='OBJ2'>Cainna Wind</marker> of enemy hostiles", STR_OBJ2, STR_OBJ2];
		tskObj2 setSimpleTaskDestination (getMarkerPos "OBJ2");
	};
	if(isNil "tskObj1") then {
		tskObj1 = player createSimpleTask [STR_OBJ1];
		tskObj1 setSimpleTaskDescription ["Patrol and clear <marker name='OBJ1'>Lina</marker> of enemy hostiles", STR_OBJ1, STR_OBJ1];
		tskObj1 setSimpleTaskDestination (getMarkerPos "OBJ1");
		player setCurrentTask tskObj1;
	};

};

task1 = {
	if (taskState tskObj1 != "SUCCEEDED") then {
		tskObj1 setTaskState "SUCCEEDED";//"FAILED", "CANCELED", "CREATED"
		"OBJ1" setMarkerColor "ColorGreen";		
		[playerSide, "Base"] sideChat "Lina cleared";
	};
};

task2 = {
	if (taskState tskObj2 != "SUCCEEDED") then {
		tskObj2 setTaskState "SUCCEEDED";//"FAILED", "CANCELED", "CREATED"
		"OBJ2" setMarkerColor "ColorGreen";
		[playerSide, "Base"] sideChat "Cainna Wind cleared";
	};
};

task3 = {
	if (taskState tskObj3 != "SUCCEEDED") then {
		tskObj3 setTaskState "SUCCEEDED";//"FAILED", "CANCELED", "CREATED"
		"OBJ3" setMarkerColor "ColorGreen";
		[playerSide, "Base"] sideChat "Fishala cleared";
	};
};

task4 = {
	if (taskState tskObj4 != "SUCCEEDED") then {
		tskObj4 setTaskState "SUCCEEDED";//"FAILED", "CANCELED", "CREATED"
		"OBJ4" setMarkerColor "ColorGreen";
		[playerSide, "Base"] sideChat "Camara cleared";
	};
};

task5 = {
	if (taskState tskObj5 != "SUCCEEDED") then {
		tskObj5 setTaskState "SUCCEEDED";//"FAILED", "CANCELED", "CREATED"
		"OBJ5" setMarkerColor "ColorGreen";
		[playerSide, "Base"] sideChat "Ramon's Plantation cleared";
	};
};

Briefing = {
	waitUntil{!isNil "tasksPublicVariable"};
	_select = _this select 0;
	if (!isNil "_select") then {
		switch (_select) do {
			case 1: {
				if(!(tasksPublicVariable select 0)) then {
					[] call task1;
					tasksPublicVariable set [0, true];
				};
			};
			case 2: {
				if(!(tasksPublicVariable select 1)) then {
					[] call task2;
					tasksPublicVariable set [1, true];
				};
			};
			case 3: {
				if(!(tasksPublicVariable select 2)) then {
					[] call task3;
					tasksPublicVariable set [2, true];
				};
			};
			case 4: {
				if(!(tasksPublicVariable select 3)) then {
					[] call task4;
					tasksPublicVariable set [3, true];
				};
			};
			case 5: {
				if(!(tasksPublicVariable select 4)) then {
					[] call task5;
					tasksPublicVariable set [4, true];
				};
			};
		};
		PublicVariable "tasksPublicVariable";
	} else {
		if (isNil "tskCredits") then {
			[] call taskSetup;
		};
		if (tasksPublicVariable select 0) then {
			[] call task1;			
		};
		if (tasksPublicVariable select 1) then {
			[] call task2;			
		};
		if (tasksPublicVariable select 2) then {
			[] call task3;			
		};
		if (tasksPublicVariable select 3) then {
			[] call task4;			
		};
		if (tasksPublicVariable select 4) then {
			[] call task5;			
		};
	};	
};

_task = _this select 0;
//hint format["Outside: %1", _task];
[_task] call Briefing;
PublicVariable "tasksPublicVariable";

"tasksPublicVariable" addPublicVariableEventHandler {
//	hint format["Inside: %1", tasksPublicVariable];
	[] call Briefing;
};
